<template>
  <div id="app">
    <header>
      <div class="left">
        <img src="/logo.png">

        <h1>Goverage</h1>
        <h2>Code Coverage & Testsuite Reports</h2>
      </div>
      <div class="right">
        <v-select :options="projectOptions" v-model="selectedProject" :searchable="false" :clearSearchOnSelect="false" />
      </div>
    </header>

    <div v-if="project">
      <Project :project="project" />
    </div>
    <div class="placeholder" v-else>
      <h2>Please select a project to monitor</h2>
    </div>

  </div>
</template>

<script>
import axios from 'axios'
import vSelect from 'vue-select'
import Project from './components/Project'

export default {
  name: 'app',
  components: {
    'v-select': vSelect,
    Project
  },
  data () {
    return {
      projectOptions: [],
      projects: [],
      selectedProject: null,
      project: null
    }
  },
  watch: {
    selectedProject: function (selectedProject) {
      if (!selectedProject) {
        this.project = null
        return
      }

      window.location.hash = selectedProject.value
      this.project = this.projects[selectedProject.value]
    }
  },
  mounted () {
    let url = '/projects'

    if (process.env.NODE_ENV === 'development') {
      url = 'http://localhost:1515' + url
    }

    let selectedProject;

    if (window.location.hash) {
      selectedProject = window.location.hash.substring(1)
    }

    axios.get(url).then(response => {
      this.projectOptions = response.data.data.map((data) => {
        const option = {
          label: data.attributes.label,
          value: data.attributes.name
        }

        if (selectedProject && option.value === selectedProject) {
          selectedProject = option
        }

        return option
      })

      this.projects = []

      for(const project of response.data.data) {
        this.projects[project.attributes.name] = project
      }

      if (selectedProject) {
        this.selectedProject = selectedProject
      }
    })
  }
}
</script>

<style>
body {
  font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
  color: #404040;
  margin: 0;
  max-height: 100vh;
}

h1 {
  text-transform: uppercase;
  letter-spacing: 0.15rem;
  font-weight: 400;
  margin: 1rem;
}

h2 {
  font-weight: 200;
  margin: 1rem;
}

header {
  display: flex;
  align-items: center;
  border-bottom: 2px solid #888888;
  background: #f0f0f0;
}

.left {
  display: flex;
  align-items: center;
  flex: 1;
}

.right {
  margin: 1rem;
}

.placeholder {
  margin-top: 5rem;
  display: flex;
  align-items: center;
  justify-content: center;
}

.placeholder h2 {
  font-size: 3rem;
  letter-spacing: 0.3rem;
  color: #888888;
}

.v-select {
  background: #ffffff;
  min-width: 400px;
}

header img {
  width: 50px;
  height: 50px;
  margin: 1rem;
}

</style>
